<template>
  <div class="dialog" v-if="visible">
    <div class="dialog-mask"></div>
    <div class="dialog-content" :style="getDialogContentStyle()">
      <div class="dialog-header" v-if="isHeader">
        <div class="close" @click="handleClose">
          <svg-icon iconClass="dialog_close" class="dialog-close"></svg-icon>
        </div>
        <div class="title" v-if="title">
          {{ title }}
        </div>
        <div class="select">
          <slot name="select"></slot>
        </div>
      </div>
      <hr v-if="isBorderLine" class="hr" />
      <div class="dialog-body">
        <slot></slot>
      </div>
      <div class="dialog-footer" v-if="isFooter">
        <div @click="handleOk" class="confirm" v-if="isConfirm">
          <div class="content">
            {{ confirmContent }}
          </div>
        </div>
        <div @click="handleCancel" class="cancel" v-if="isCancel">
          <div class="content">
            {{ cancelContent }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "SystemDialog", // 系统设置中的dialog
  data() {
    return {};
  },
  props: {
    title: {
      type: String,
      default: "",
    }, // dialog标题
    visible: {
      type: Boolean,
      default: true,
    }, // dialog显示或隐藏
    isBorderLine: {
      type: Boolean,
      default: false,
    }, // 是否需要分隔线
    isFooter: {
      type: Boolean,
      default: true,
    }, // 是否需要footer
    isConfirm: {
      type: Boolean,
      default: true,
    }, // 是否需要确定按钮
    isCancel: {
      type: Boolean,
      default: true,
    }, // 是否需要取消按钮
    isHeader: {
      type: Boolean,
      default: true,
    }, // 是否需要footer
    confirmContent: {
      type: String,
      default: "确定",
    }, // 确认div中的内容
    cancelContent: {
      type: String,
      default: "取消",
    }, // 取消div中的内容
    width: {
      type: String,
      default: "",
    }, // dialog整体宽度
    height: {
      type: String,
      default: "",
    }, // dialog整体高度
  },
  methods: {
    handleCancel() {
      this.$emit("handleCancel");
    }, // 点击取消
    handleOk() {
      this.$emit("handleOk");
    }, // 点击确定
    handleClose() {
      this.$emit("handleClose");
    }, // 点击关闭
    getDialogContentStyle() {
      return {
        width: this.width,
      };
    }, // 根据传参设置dialog的宽度
  },
  computed: {},
};
</script>

<style scoped lang="scss">
.dialog {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 9999;
  display: flex;
  justify-content: center;
  align-items: center;
}

.dialog-mask {
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.5);
}

.dialog-content {
  min-width: 400px;
  min-height: 310px;
  background-color: #e7edf5;
  border-radius: 12px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.2);
  z-index: 10;
  //position: relative;
  font-size: 29px;
  font-weight: 500;
  color: #050505;
  line-height: 30px;
  letter-spacing: 2px;
  display: flex;
  flex-direction: column;

  .hr {
    background-color: #d0d5dc;
  }
  .dialog-header {
    padding: 16px;
    font-size: 18px;
    font-weight: bold;
    display: flex;
    justify-content: space-between;
    align-items: center;

    .close {
      display: flex;
      justify-content: center;
      align-items: center;

      .dialog-close {
        width: 26px;
        height: 26px;
      }
    }

    .title {
      font-size: 36px;
      font-weight: normal;
      line-height: normal;
      letter-spacing: 0.05em;
    }
  }

  .dialog-body {
    flex-grow: 1;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    bottom: 78px;
  }

  .dialog-footer {
    display: flex;
    height: 78px; // 这里看ui暂时应该是定死的，后面有需要再改
    font-size: 29px;
    width: 100%;

    .confirm {
      border-top: 1px solid #d8d8d8;
      color: #4594ee;
      background-color: #ffffff;
      display: flex;
      justify-content: center;
      align-content: center;
      box-sizing: border-box;
      line-height: 78px;
      border-radius: 0 0 12px 12px;
      flex: 1;
      .content {
        height: auto;
      }
    }

    .cancel {
      background: #ffffff;
      color: #343434;
      border: none;
      display: flex;
      justify-content: center;
      align-content: center;
      box-sizing: border-box;
      line-height: 78px;
      border-radius: 0 0 12px 12px;
      border-top: 1px solid #d8d8d8;
      border-left: 1px solid #d8d8d8;
      flex: 1;

      .content {
        height: auto;
      }
    }
  }
}
</style>
